/*
 * $Id: //depot/sw/branches/1.3_USB_LINUX_port/src/USB/wlan/host/common/wlanglobal.c#1 $
 *
 * Copyright (c) 2000-2003 Atheros Communications, Inc., All Rights Reserved
 *
 * Global variable definitions.
 */

#include "wlandrv.h"

WLAN_DRV_INFO gDrvInfo;         /* global driver information */

WLAN_MACADDR broadcastMacAddr = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
WLAN_MACADDR nullMacAddr      = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};

const EAPOL_SNAP_HDR eapolSnap =
    { {0xAA, 0xAA, 0x03, 0x00, 0x00, 0x00, 0x88, 0x8e} };

const A_UINT8 ouiMicrosoft[3] = { 0x00, 0x50, 0xF2 };
const A_UINT8 ouiAtheros[3]   = { 0x00, 0x03, 0x7f };
const A_UINT8 ouiAironet[3]   = { 0x00, 0x40, 0x96 };

const A_UINT8 eidMap[256] = {
    MAP_ELE_SSID,               /* 0   */
    MAP_ELE_SUPPORTED_RATES,    /* 1   */
    MAP_ELE_FH_PARAM_SET,       /* 2   */
    MAP_ELE_DS_PARAM_SET,       /* 3   */
    MAP_ELE_CF_PARAM_SET,       /* 4   */
    MAP_ELE_TIM,                /* 5   */
    MAP_ELE_IBSS_PARAM_SET,     /* 6   */
    MAP_ELE_COUNTRY_INFO,       /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 10  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_CHLG_TEXT,          /* 16  */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 20  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 30  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 40  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_NONERP,             /* 42  */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_EXT_SUPPORTED_RATES,/* 50  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 60  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 70  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 80  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 90  */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 100 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 110 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 120 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 130 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_CKIP_CSN,           /* 133 */ 
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 140 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_CCX_APADDR,         /* 149 */
    MAP_ELE_TPC,                /* 150 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 160 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 170 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 180 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 190 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 200 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 210 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 220 */
    MAP_ELE_ESCAPE,             /* 221 */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 230 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 240 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE,             /* 5   */
    MAP_ELE_ESCAPE,             /* 6   */
    MAP_ELE_ESCAPE,             /* 7   */
    MAP_ELE_ESCAPE,             /* 8   */
    MAP_ELE_ESCAPE,             /* 9   */
    MAP_ELE_ESCAPE,             /* 250 */
    MAP_ELE_ESCAPE,             /* 1   */
    MAP_ELE_ESCAPE,             /* 2   */
    MAP_ELE_ESCAPE,             /* 3   */
    MAP_ELE_ESCAPE,             /* 4   */
    MAP_ELE_ESCAPE              /* 5   */
};

#ifdef DEBUG
/*
 * The following is used to dynamically enable/disable assertion.
 * 1 = asserts enabled
 * 0 = asserts disabled.
 */
int asserts = 1;
#else
int asserts = 0;
#endif
